#pragma once
#include <easy2d/e2dbase.h>

namespace easy2d 
{


class Action;
class Transition;
class SceneManager;

class Node :
	public Object
{
	friend class Scene;
	friend class Transition;
	friend class SceneManager;

public:
	// ڵ
	struct Property
	{
		bool visable;		// ɼ
		float posX;			// X 
		float posY;			// Y 
		float width;		// 
		float height;		// ߶
		float opacity;		// ͸
		float anchorX;		// ê X 
		float anchorY;		// ê Y 
		float scaleX;		// 
		float scaleY;		// 
		float rotation;		// תǶ
		float skewAngleX;	// бǶ
		float skewAngleY;	// бǶ
	};

public:
	Node();

	virtual ~Node();

	// ½ڵ
	virtual void onUpdate() {}

	// Ⱦڵ
	virtual void onRender() {}

	// ȡڵʾ״̬
	bool isVisible() const;

	// ȡڵ
	String getName() const;

	// ȡڵƵ Hash ֵ
	size_t getHashName() const;

	// ȡڵͼ˳
	int getOrder() const;

	// ȡڵ
	float getPosX() const;

	// ȡڵ
	float getPosY() const;

	// ȡڵ
	Point getPos() const;

	// ȡڵ
	float getWidth() const;

	// ȡڵ߶
	float getHeight() const;

	// ȡڵȣţ
	float getRealWidth() const;

	// ȡڵ߶ȣţ
	float getRealHeight() const;

	// ȡڵСţ
	Size getRealSize() const;

	// ȡڵê
	float getAnchorX() const;

	// ȡڵê
	float getAnchorY() const;

	// ȡڵС
	Size getSize() const;

	// ȡڵű
	float getScaleX() const;

	// ȡڵű
	float getScaleY() const;

	// ȡڵбǶ
	float getSkewX() const;

	// ȡڵбǶ
	float getSkewY() const;

	// ȡڵתǶ
	float getRotation() const;

	// ȡڵ͸
	float getOpacity() const;

	// ȡڵ
	Property getProperty() const;

	// ȡ߿
	Rect getBounds() const;

	// ȡаΧ
	Rect getBoundingBox() const;

	// ȡά任
	Matrix32 getTransform() const;

	// ȡά任
	Matrix32 getInverseTransform() const;

	// ȡڵ
	Node * getParent() const;

	// ȡڵڳ
	Scene * getParentScene() const;

	// Ƿ
	bool containsPoint(Point const& point);

	// ýڵǷʾ
	void setVisible(
		bool value
	);

	//  onUpdate 
	void setAutoUpdate(
		bool bAutoUpdate
	);

	// ýڵ
	void setName(
		const String& name
	);

	// ýڵ
	void setPosX(
		float x
	);

	// ýڵ
	void setPosY(
		float y
	);

	// ýڵ
	void setPos(
		const Point & point
	);

	// ýڵ
	void setPos(
		float x,
		float y
	);

	// ڵ̶
	void setPosFixed(
		bool fixed
	);

	// ƶڵ
	void movePosX(
		float x
	);

	// ƶڵ
	void movePosY(
		float y
	);

	// ƶڵ
	void movePos(
		float x,
		float y
	);

	// ƶڵ
	void movePos(
		const Vector2 & v
	);

	// ýڵͼ˳
	// ĬΪ 0
	void setOrder(
		int order
	);

	// úű
	// ĬΪ 1.0f
	void setScaleX(
		float scaleX
	);

	// ű
	// ĬΪ 1.0f
	void setScaleY(
		float scaleY
	);

	// ű
	// ĬΪ (1.0f, 1.0f)
	void setScale(
		float scaleX,
		float scaleY
	);

	// ű
	// ĬΪ 1.0f
	void setScale(
		float scale
	);

	// úбǶ
	// ĬΪ 0
	void setSkewX(
		float angleX
	);

	// бǶ
	// ĬΪ 0
	void setSkewY(
		float angleY
	);

	// бǶ
	// ĬΪ (0, 0)
	void setSkew(
		float angleX,
		float angleY
	);

	// תǶ
	// ĬΪ 0
	void setRotation(
		float rotation
	);

	// ͸
	// ĬΪ 1.0f, Χ [0, 1]
	void setOpacity(
		float opacity
	);

	// êĺλ
	// ĬΪ 0, Χ [0, 1]
	void setAnchorX(
		float anchorX
	);

	// êλ
	// ĬΪ 0, Χ [0, 1]
	void setAnchorY(
		float anchorY
	);

	// êλ
	// ĬΪ (0, 0), Χ [0, 1]
	void setAnchor(
		float anchorX,
		float anchorY
	);

	// ޸Ľڵ
	void setWidth(
		float width
	);

	// ޸Ľڵ߶
	void setHeight(
		float height
	);

	// ޸ĽڵС
	void setSize(
		float width,
		float height
	);

	// ޸ĽڵС
	void setSize(
		Size size
	);

	// ýڵ
	void setProperty(
		Property prop
	);

	// ӽڵ
	void addChild(
		Node * child,
		int order = 0	/* Ⱦ˳ */
	);

	// Ӷӽڵ
	void addChild(
		const std::vector<Node*>& nodes,	/* ڵ */
		int order = 0						/* Ⱦ˳ */
	);

	// ȡͬӽڵ
	std::vector<Node*> getChildren(
		const String& name
	) const;

	// ȡͬӽڵ
	Node* getChild(
		const String& name
	) const;

	// ȡӽڵ
	const std::vector<Node*>& getAllChildren() const;

	// ȡӽڵ
	int getChildrenCount() const;

	// Ƴӽڵ
	bool removeChild(
		Node* child
	);

	// Ƴͬӽڵ
	void removeChildren(
		const String& childName
	);

	// ӸڵƳ
	void removeFromParent();

	// Ƴнڵ
	void removeAllChildren();

	// ַ¼
	void dispatch(Event* evt);

	// ִж
	void runAction(
		Action * action
	);

	// 
	void resumeAction(
		const String& name
	);

	// ͣ
	void pauseAction(
		const String& name
	);

	// ֹͣ
	void stopAction(
		const String& name
	);

	// ͣ
	void resumeAllActions();

	// ͣж
	void pauseAllActions();

	// ֹͣж
	void stopAllActions();

	// 
	Listener* addListener(
		const Listener::Callback& func,	/* ûʱִк */
		const String& name = L"",		/*  */
		bool paused = false				/* Ƿͣ */
	);

	// ײ
	void addListener(
		Listener* listener		/*  */
	);

	// Ƴ
	void removeListener(
		Listener* listener		/*  */
	);

	// 
	void startListener(
		const String& name
	);

	// ֹͣ
	void stopListener(
		const String& name
	);

	// Ƴ
	void removeListener(
		const String& name
	);

	// м
	void startAllListeners();

	// ֹͣм
	void stopAllListeners();

	// Ƴм
	void removeAllListeners();

	// ޸ĽڵĬêλ
	static void setDefaultAnchor(
		float defaultAnchorX,
		float defaultAnchorY
	);

protected:
	// ½ڵ
	void _update();

	// Ⱦڵ
	void _render();

	// ýڵڳ
	void _setParentScene(
		Scene * scene
	);

	// ¶ά任
	void _updateTransform() const;

	// ¶ά任
	void _updateInverseTransform() const;

	// ӽڵ
	void _sortChildren();

	// ½ڵ͸
	void _updateOpacity();

	// ¼
	void __updateListeners(Event* evt);

	// ռ
	void __clearListeners();

protected:
	bool		_visible;
	bool		_autoUpdate;
	bool		_needSort;
	bool		_positionFixed;
	float		_posX;
	float		_posY;
	float		_width;
	float		_height;
	float		_scaleX;
	float		_scaleY;
	float		_rotation;
	float		_skewAngleX;
	float		_skewAngleY;
	float		_displayOpacity;
	float		_realOpacity;
	float		_anchorX;
	float		_anchorY;
	int			_nOrder;
	String		_name;
	size_t		_hashName;
	Scene *		_parentScene;
	Node *		_parent;
	
	std::vector<Node*>	_children;
	std::vector<Listener*> _listeners;

	mutable bool		_dirtyTransform;
	mutable Matrix32	_transform;
	mutable bool		_dirtyInverseTransform;
	mutable Matrix32	_inverseTransform;
};


// 
class Scene :
	public Node
{
public:
	Scene();

	virtual ~Scene();

	// дڽʱԶִ
	virtual void onEnter() {}

	// д뿪ʱԶִ
	virtual void onExit() {}

	// дڹرմʱִУ false ֹڹرգ
	virtual bool onCloseWindow() { return true; }
};


// 
class Sprite :
	public Node
{
public:
	Sprite();

	explicit Sprite(
		Image * image
	);

	explicit Sprite(
		const String& filePath	/* ͼƬļ· */
	);

	explicit Sprite(
		int resNameId,			/* ͼƬԴ */
		const String& resType	/* ͼƬԴ */
	);

	explicit Sprite(
		const String& filePath,	/* ͼƬļ· */
		const Rect& cropRect	/* ü */
	);

	explicit Sprite(
		int resNameId,			/* ͼƬԴ */
		const String& resType,	/* ͼƬԴ */
		const Rect& cropRect	/* ü */
	);

	virtual ~Sprite();

	// ͼƬļ
	bool open(
		const String& filePath
	);

	// ͼƬԴ
	bool open(
		int resNameId,			/* ͼƬԴ */
		const String& resType	/* ͼƬԴ */
	);
	
	// ͼƬ
	bool open(
		Image * image
	);

	// ͼƬüΪ
	void crop(
		const Rect& cropRect	/* ü */
	);

	// ȡ Image 
	virtual Image * getImage() const;

	// Ⱦ
	virtual void onRender() override;

protected:
	Image * _image;
};


// ı
class Text :
	public Node
{
public:
	// ı뷽ʽ
	enum class Align
	{
		Left,		/*  */
		Right,		/* Ҷ */
		Center		/* ж */
	};

	// ıʽ
	class Style
	{
	public:
		Color		color;				// ɫ
		Align		alignment;			// 뷽ʽ
		bool		wrapping;			// Զ
		float		wrappingWidth;		// Զп
		float		lineSpacing;		// м
		bool		hasUnderline;		// »
		bool		hasStrikethrough;	// ɾ
		bool		hasOutline;			// ʾ
		Color		outlineColor;		// ɫ
		float		outlineWidth;		// ߿
		LineJoin	outlineJoin;		// ཻʽ

	public:
		Style();

		Style(
			Color color,
			Align alignment = Align::Left,
			bool wrapping = false,
			float wrappingWidth = 0.0,
			float lineSpacing = 0.0,
			bool hasUnderline = false,
			bool hasStrikethrough = false,
			bool hasOutline = true,
			Color outlineColor = Color(Color::Black, 0.5),
			float outlineWidth = 1.0,
			LineJoin outlineJoin = LineJoin::Round
		);
	};

public:
	Text();

	explicit Text(
		const String& text,						/*  */
		const Font& font = Font(),				/*  */
		const Style& style = Style()			/* ıʽ */
	);

	virtual ~Text();

	// ȡı
	String getText() const;

	// ȡ
	Font getFont() const;

	// ȡıʽ
	Style getStyle() const;

	// ȡ
	String getFontFamily() const;

	// ȡǰֺ
	float getFontSize() const;

	// ȡǰϸֵ
	UINT getFontWeight() const;

	// ȡɫ
	Color getColor() const;

	// ȡɫ
	Color getOutlineColor() const;

	// ȡ߿
	float getOutlineWidth() const;

	// ȡཻʽ
	LineJoin getOutlineJoin() const;

	// ȡıʾ
	int getLineCount() const;

	// Ƿб
	bool isItalic() const;

	// Ƿʾɾ
	bool hasStrikethrough() const;

	// Ƿʾ»
	bool hasUnderline() const;

	// Ƿʾ
	bool hasOutline() const;

	// ı
	void setText(
		const String& text
	);

	// ıʽ
	void setStyle(
		const Style& style
	);

	// 
	void setFont(
		const Font& font
	);

	// 
	void setFontFamily(
		const String& family
	);

	// ֺţĬֵΪ 22
	void setFontSize(
		float size
	);

	// ϸֵĬֵΪ Text::Font::Weight::Normal
	void setFontWeight(
		UINT weight
	);

	// ɫĬֵΪ Color::WHITE
	void setColor(
		Color color
	);

	// б壨ĬֵΪ false
	void setItalic(
		bool value
	);

	// 򿪻رıԶУĬΪرգ
	void setWrapping(
		bool wrapping
	);

	// ıԶеĿȣĬΪ 0
	void setWrappingWidth(
		float wrappingWidth
	);

	// мࣨĬΪ 0
	void setLineSpacing(
		float lineSpacing
	);

	// ö뷽ʽĬΪ Align::Left
	void setAlignment(
		Align align
	);

	// »ߣĬֵΪ false
	void setUnderline(
		bool hasUnderline
	);

	// ɾߣĬֵΪ false
	void setStrikethrough(
		bool hasStrikethrough
	);

	// Ƿʾ
	void setOutline(
		bool hasOutline
	);

	// ɫ
	void setOutlineColor(
		Color outlineColor
	);

	// ߿
	void setOutlineWidth(
		float outlineWidth
	);

	// ཻʽ
	void setOutlineJoin(
		LineJoin outlineJoin
	);

	// Ⱦ
	virtual void onRender() override;

protected:
	// Ű
	void _reset();

	// ָʽ
	void _createFormat();

	// ֲ
	void _createLayout();

protected:
	String	_text;
	Font	_font;
	Style	_style;
	IDWriteTextFormat * _textFormat;
	IDWriteTextLayout * _textLayout;
};


// ť
class Button :
	public Node
{
public:
	using Callback = Function<void()>;

	Button();

	explicit Button(
		Node * normal,					/* ͨ״̬ */
		const Callback& func = nullptr	/* ťִк */
	);

	explicit Button(
		Node * normal,					/* ͨ״̬ */
		Node * selected,				/* 갴״̬ */
		const Callback& func = nullptr	/* ťִк */
	);

	explicit Button(
		Node * normal,					/* ͨ״̬ */
		Node * mouseover,				/* ״̬ */
		Node * selected,				/* 갴״̬ */
		const Callback& func = nullptr	/* ťִк */
	);

	explicit Button(
		Node * normal,					/* ͨ״̬ */
		Node * mouseover,				/* ״̬ */
		Node * selected,				/* ״̬ */
		Node * disabled,				/* ť״̬ */
		const Callback& func = nullptr	/* ťִк */
	);

	// ȡť״̬ûǽ
	bool isEnable() const;

	// ðťû
	void setEnable(
		bool enable
	);

	// һʾİť
	virtual void setNormal(
		Node * normal
	);

	// 밴ťʱʾİť
	virtual void setMouseOver(
		Node * mouseover
	);

	// 갴°ťʱʾİť
	virtual void setSelected(
		Node * selected
	);

	// ðťʱʾİť
	virtual void setDisabled(
		Node * disabled
	);

	// ðťִк
	void setClickFunc(
		const Callback& func
	);

protected:
	// ť״̬ö
	enum class ButtonState { Normal, Mouseover, Selected };

	// ðť״̬
	virtual void _setState(ButtonState state);

	// ˢ°ťʾ
	virtual void _updateVisiable();

	// ִаť
	virtual void _runCallback();

	void updateStatus(Event* evt);

protected:
	bool		_enable;
	bool		_isSelected;
	bool		_isHover;
	bool		_isPressed;
	Node *		_normal;
	Node *		_mouseover;
	Node *		_selected;
	Node *		_disabled;
	ButtonState	_state;
	Callback	_func;
};


// ذť
class ToggleButton :
	public Button
{
public:
	ToggleButton();

	explicit ToggleButton(
		Node * onNormal,				/* ťʱͨ״̬ */
		Node * offNormal,				/* ťرʱͨ״̬ */
		const Callback& func = nullptr	/* ťִк */
	);

	explicit ToggleButton(
		Node * onNormal,				/* ťʱͨ״̬ */
		Node * offNormal,				/* ťرʱͨ״̬ */
		Node * onSelected,				/* ťʱ갴״̬ */
		Node * offSelected,				/* ťرʱ갴״̬ */
		const Callback& func = nullptr	/* ťִк */
	);

	explicit ToggleButton(
		Node * onNormal,				/* ťʱͨ״̬ */
		Node * offNormal,				/* ťرʱͨ״̬ */
		Node * onMouseOver,				/* ťʱ״̬ */
		Node * offMouseOver,			/* ťرʱ״̬ */
		Node * onSelected,				/* ťʱ갴״̬ */
		Node * offSelected,				/* ťرʱ갴״̬ */
		const Callback& func = nullptr	/* ťִк */
	);

	explicit ToggleButton(
		Node * onNormal,				/* ťʱͨ״̬ */
		Node * offNormal,				/* ťرʱͨ״̬ */
		Node * onMouseOver,				/* ťʱ״̬ */
		Node * offMouseOver,			/* ťرʱ״̬ */
		Node * onSelected,				/* ťʱ갴״̬ */
		Node * offSelected,				/* ťرʱ갴״̬ */
		Node * onDisabled,				/* ťʱ״̬ */
		Node * offDisabled,				/* ťرʱ״̬ */
		const Callback& func = nullptr	/* ťִк */
	);

	// ȡ״̬򿪻رգ
	bool getState() const;

	// ÿذť״̬򿪻رգ
	void setState(
		bool bState
	);

	// ðť״̬ʾİť
	virtual void setNormal(
		Node * normal
	) override;

	// ðť״̬£밴ťʱʾİť
	virtual void setMouseOver(
		Node * mouseover
	) override;

	// ðť״̬£갴°ťʱʾİť
	virtual void setSelected(
		Node * selected
	) override;

	// ðť״̬£ʱʾİť
	virtual void setDisabled(
		Node * disabled
	) override;

	// ðťر״̬ʾİť
	void setNormalOff(
		Node * normal
	);

	// ðťر״̬£밴ťʱʾİť
	void setMouseOverOff(
		Node * mouseover
	);

	// ðťر״̬£갴°ťʱʾİť
	void setSelectedOff(
		Node * selected
	);

	// ðťر״̬£ťʱʾİť
	void setDisabledOff(
		Node * disabled
	);

protected:
	// ˢ°ť
	void _updateState();

	// ִаť
	void _runCallback() override;

protected:
	Node*	_normalOn;
	Node*	_mouseoverOn;
	Node*	_selectedOn;
	Node*	_disabledOn;
	Node*	_normalOff;
	Node*	_mouseoverOff;
	Node*	_selectedOff;
	Node*	_disabledOff;
	bool	_toggle;
};


// ˵
class Menu :
	public Node
{
public:
	Menu();

	explicit Menu(
		const std::vector<Button*>& buttons	/* ť */
	);

	// ȡ˵Ƿ
	bool isEnable() const;

	// ȡ˵еİť
	size_t getButtonCount() const;

	// ò˵û
	void setEnable(
		bool enable
	);

	// Ӱť
	void addButton(
		Button * button
	);

	// Ƴť
	bool removeButton(
		Button * button
	);

	// ȡаť
	const std::vector<Button*>& getAllButtons() const;

protected:
	bool _enable;
	std::vector<Button*> _buttons;
};

}